function filepath1,file
;
;+ 
; function filepath1,file
; checks the directories in !path and returns the total path of 
; the input file.
; example:  print,filepath('xdemo.pro')
; usr/local/lib/idl
;
; MSR 95-03-21
; MSR 96-08-22 Searchs also in current directory.
; MSR 97-01-13 MSR ports to Window
; MSR 97-10-27 MSR sdep() used.
;
;-
;
if sdep() EQ 'WINDOWS' then begin
  iflg = strparse(!path,';',list) 
endif else begin
  iflg = strparse(!path,':',list)
  list = ['./',list] 
endelse
separator = sdep(/ds)
for i=0,n_elements(list)-1 do begin
  aa = findfile(list(i)+separator+file)
  if aa(0) NE '' then return,list(i)
endfor
return,''
end
